﻿using System;
using System.Web;
using System.Collections.Generic;
using Infragistics.Web.UI.GridControls;
using Infragistics.WebUI.WebDataInput;

public partial class Default : Infragistics.Web.SampleBrowser.Core.Framework.Web.UI.ASPNET.SamplePage
{
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        
        
        this.whdg1.RowIslandsPopulating += new ContainerRowCancelEventHandler(whdg1_RowIslandsPopulating);
        if (Session["SuppliersAndProductsDataSet"] == null)
            Session["SuppliersAndProductsDataSet"] = NWindClient.GetSuppliers();

        this.whdg1.DataSource = Session["SuppliersAndProductsDataSet"];      

    }

     

    void whdg1_RowIslandsPopulating(object sender, ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;

        Supplier sp = (((Infragistics.Web.UI.Framework.Data.ListNode)e.Row.DataItem)).Item as Supplier;
        sp.Products = new List<Products>(NWindClient.GetProducts(Convert.ToInt32(sp.SupplierID)));   

        ContainerGrid containerGrid = new ContainerGrid();      
        e.Row.RowIslands.Add(containerGrid);
        containerGrid.AutoGenerateColumns = false;
        containerGrid.Enabled = true;

        containerGrid.DataSource = sp.Products;
        //containerGrid.DataBind();

        CreateField(containerGrid, "ProductID");
        CreateField(containerGrid, "SupplierID");
        CreateField(containerGrid, "ProductName");
        CreateField(containerGrid, "QuantityPerUnit");
        containerGrid.DataKeyFields = "ProductID";
   }

    private void CreateField(ContainerGrid containerGrid, string fieldName)
    {
        TemplateDataField field2 = new TemplateDataField();
        field2.Key = fieldName;
        field2.Header.Text = fieldName;
        containerGrid.Columns.Add(field2);
        TemplateDataField templateColumn2 = (TemplateDataField)containerGrid.Columns[fieldName];
        templateColumn2.ItemTemplate = new PlaceHolderTemplate();
    }
  

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //this.whdg1.DataBind();
        }


    }

    public class PlaceHolderTemplate : System.Web.UI.ITemplate
    {      

        public PlaceHolderTemplate()
        {   }      

        public void InstantiateIn(System.Web.UI.Control container)
        {            
            WebImageButton ib = new WebImageButton();
            container.Controls.Add(ib);

            string _key = ((GridRecordItem)((Infragistics.Web.UI.TemplateContainer)container).Item).Column.Key;
            ib.Text = GetValue(_key, (Products)((Infragistics.Web.UI.TemplateContainer)container).DataItem);
            ib.CommandArgument = ((Products)((Infragistics.Web.UI.TemplateContainer)container).DataItem).ProductID.ToString();
            ib.ID = _key;
            
            ib.AutoSubmit = true;
            ib.Enabled = true;
            ib.Attributes.Add("Width", "100%");
            ib.Attributes.Add("Height", "100%");
            ib.EnableTheming = true;
          
            ib.HoverAppearance.Style.BorderStyle = System.Web.UI.WebControls.BorderStyle.Dashed;
            ib.HoverAppearance.Style.Font.Bold = true;           
            ib.Appearance.Style.BackColor = System.Drawing.Color.Transparent;
            
            ib.Click += new ClickHandler(ib_Click);                   
            
        }

        protected string GetValue(string key, Products product)
        {
            string returnValue = string.Empty;

            switch (key)
            {
                case "ProductID":
                    returnValue = product.ProductID.ToString();
                    break;
                case "ProductName":
                    returnValue = product.ProductName.ToString();
                    break;
                case "SupplierID":
                    returnValue = product.SupplierID.ToString();
                    break;
                case "QuantityPerUnit":
                    returnValue = product.QuantityPerUnit.ToString();
                    break;
                default:
                    break;
            }
            return returnValue;
        }

        void ib_Click(object sender, ButtonEventArgs e)
        {
        }

     



    }

}
